---
image: docker:latest

stages:
  - check
  - build

services:
  - docker:dind

before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY

include:
  - template: Security/Secret-Detection.gitlab-ci.yml

secret_detection:
  extends: .secret-analyzer
  stage: check
  variables:
    SECRET_DETECTION_HISTORIC_SCAN: "false"
    SECRET_DETECTION_REPORT_FILE: "gl-secret-detection-report.json"
  artifacts:
    reports:
      secret_detection: $SECRET_DETECTION_REPORT_FILE
    expire_in: 7 days
  rules:
    - if: $CI_PIPELINE_SOURCE == "push"
    - if: $CI_PIPELINE_SOURCE == "schedule" && $CI_COMMIT_BRANCH == "develop"
    - if: $CI_PIPELINE_SOURCE == "trigger" && $CI_COMMIT_TAG == null
    - if: $CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH == null
  allow_failure: false
  before_script:
    - apk add --no-cache jq
  script:
    - /analyzer run
    - |
      if [ -f "$SECRET_DETECTION_REPORT_FILE" ]; then
        if [ "$(jq ".vulnerabilities | length" $SECRET_DETECTION_REPORT_FILE)" -gt 0 ]; then
          echo "Vulnerabilities detected!"
          echo "Please check the $SECRET_DETECTION_REPORT_FILE security file."
          echo "Or run gitleak locally on your repository."
          exit 1
        fi
      else
        echo "Artifact $SECRET_DETECTION_REPORT_FILE does not exist."
        echo "No evaluation can be performed."
      fi      

build:
  stage: build
  script:
    - docker build --pull -t "${CI_REGISTRY_IMAGE}:latest" -t "$CI_REGISTRY_IMAGE:$DOCKER_ENV_CI_COMMIT_SHORT_SHA"  .
    - docker push "${CI_REGISTRY_IMAGE}:latest"
    # - docker push "$CI_REGISTRY_IMAGE:$DOCKER_ENV_CI_COMMIT_SHORT_SHA"
  only:
    - master

build-tags:
  stage: build
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG" .
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG"
  only:
    - tags
  except:
    - master

build-branch:
  stage: build
  script:
    - export BRANCH_NOSLASH=$(echo $CI_COMMIT_BRANCH | tr / -)
    - docker build --pull -t "$CI_REGISTRY_IMAGE:$BRANCH_NOSLASH" .
    - docker push "$CI_REGISTRY_IMAGE:$BRANCH_NOSLASH"
  only:
    - branches
  except:
    - master
